unit GPIOTestUnit;

{$mode objfpc}{$H+}

interface

uses Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls, Unix, LowLevelGPIO;

const
  INPUT = 0;
  OUTPUT = 1;
  GPIO17 = 17;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure PrepareGPIO;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  GPIODriver: TIoDriver;
  GPIO: TIoPort;

implementation

{$R *.lfm}

procedure TForm1.PrepareGPIO;
begin
  if GPIODriver.MapIO then
    begin
      GPIO := GpIoDriver.CreatePort(GPIO_BASE,CLOCK_BASE,GPIO_PWM);
      GPIO.SetPinMode(GPIO17,Output);
    end
  else MessageDlg('GPIO Error','Unable to map GPIO to memory.',mtError,[mbOK],0);
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  PrepareGPIO;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  GPIO.SetBit(GPIO17);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  GPIO.ClearBit(GPIO17);
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  GPIODriver.UnmapIoRegisrty(GPIO);
end;


end.
